#include <windows.h>

LRESULT CALLBACK WndProc(HWND,UINT,WPARAM,LPARAM);
HINSTANCE g_hInst;
LPSTR lpszClass="ScrWnd";

int APIENTRY WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance
		  ,LPSTR lpszCmdParam,int nCmdShow)
{
	HWND hWnd;
	MSG Message;
	WNDCLASS WndClass;
	g_hInst=hInstance;
	
	if(!hPrevInstance) {
		WndClass.cbClsExtra=0;
		WndClass.cbWndExtra=0;
		WndClass.hbrBackground=(HBRUSH)GetStockObject(WHITE_BRUSH);
		WndClass.hCursor=LoadCursor(NULL,IDC_ARROW);
		WndClass.hIcon=LoadIcon(NULL,IDI_APPLICATION);
		WndClass.hInstance=hInstance;
		WndClass.lpfnWndProc=(WNDPROC)WndProc;
		WndClass.lpszClassName=lpszClass;
		WndClass.lpszMenuName=NULL;
		WndClass.style=CS_HREDRAW | CS_VREDRAW;
		RegisterClass(&WndClass);
	}
	hWnd=CreateWindow(lpszClass,lpszClass,WS_OVERLAPPEDWINDOW | WS_HSCROLL | WS_VSCROLL,
		  CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,
		  NULL,(HMENU)NULL,hInstance,NULL);
	ShowWindow(hWnd,nCmdShow);
	
	while(GetMessage(&Message,0,0,0)) {
		TranslateMessage(&Message);
		DispatchMessage(&Message);
	}
	return Message.wParam;
}

int yPos,xPos;
int yMax,xMax;
COLORREF col[5]={RGB(255,0,0),RGB(0,255,0),RGB(0,0,255),RGB(255,0,255),RGB(255,255,0)};
LRESULT CALLBACK WndProc(HWND hWnd,UINT iMessage,WPARAM wParam,LPARAM lParam)
{
	int i,j;
	HDC hdc;
	PAINTSTRUCT ps;
	int xInc, yInc;
	SCROLLINFO si;
	HBRUSH hBrush,OldBrush;

	switch(iMessage) {
	case WM_CREATE:
		xPos=0;
		yPos=0;
		xMax=1000;
		yMax=1000;
		return 0;
	case WM_SIZE:
		si.cbSize=sizeof(SCROLLINFO);
		si.fMask=SIF_ALL | SIF_DISABLENOSCROLL;
		si.nMin=0;
		si.nMax=1000;
		si.nPage=HIWORD(lParam);
		si.nPos=yPos;
		SetScrollInfo(hWnd, SB_VERT, &si, TRUE);

		si.nPage=LOWORD(lParam);
		si.nPos=xPos;
		SetScrollInfo(hWnd, SB_HORZ, &si, TRUE);
		return 0;
	case WM_HSCROLL:
		xInc=0;
		switch (LOWORD(wParam)) {
		case SB_LINEUP:
			xInc=-1;
			break;
		case SB_LINEDOWN:
			xInc=1;
			break;
		case SB_PAGEUP:
			xInc=-20;
			break;
		case SB_PAGEDOWN:
			xInc=20;
			break;
		case SB_THUMBTRACK:
			xInc=HIWORD(wParam)-xPos;
			break;
		default:
			break;
		}
		// ο ġ ּ 0 ̻
		if (xPos+xInc < 0)
			xInc=-xPos;
		// ο ġ ִ xMax 
		if (xPos+xInc > xMax)
			xInc=xMax-xPos;
		// ο ġ 
		xPos=xPos+xInc;
		// ũѽŰ  ġ ٽ Ѵ.
		ScrollWindow(hWnd, -xInc, 0, NULL, NULL);
		SetScrollPos(hWnd, SB_HORZ, xPos, TRUE);
		return 0;
	case WM_VSCROLL:
		yInc=0;
		switch (LOWORD(wParam)) {
		case SB_LINEUP:
			yInc=-1;
			break;
		case SB_LINEDOWN:
			yInc=1;
			break;
		case SB_PAGEUP:
			yInc=-20;
			break;
		case SB_PAGEDOWN:
			yInc=20;
			break;
		case SB_THUMBTRACK:
			yInc=HIWORD(wParam)-yPos;
			break;
		default:
			break;
		}
		// ο ġ ּ 0 ̻
		if (yPos+yInc < 0)
			yInc=-yPos;
		// ο ġ ִ yMax 
		if (yPos+yInc > yMax)
			yInc=yMax-yPos;
		// yInc=max(-yPos, min(yInc, yMax-yPos));
		// ο ġ 
		yPos=yPos+yInc;
		// ũѽŰ  ġ ٽ Ѵ.
		ScrollWindow(hWnd, 0, -yInc, NULL, NULL);
		SetScrollPos(hWnd, SB_VERT, yPos, TRUE);
		return 0;
	case WM_PAINT:
		hdc=BeginPaint(hWnd, &ps);
		for (i=500,j=0;i>=100;i-=100,j++) {
			hBrush=CreateSolidBrush(col[j]);
			OldBrush=(HBRUSH)SelectObject(hdc,hBrush);
			Ellipse(hdc,500-i-xPos,500-i-yPos,500+i-xPos,500+i-yPos);
			DeleteObject(SelectObject(hdc,OldBrush));
		}
		EndPaint(hWnd, &ps);
		return 0;
	case WM_DESTROY:
		PostQuitMessage(0);
		return 0;
	}
	return(DefWindowProc(hWnd,iMessage,wParam,lParam));
}